'\"
'\" 
'\" The definitions below are for supplemental macros used in Tcl/Tk
'\" manual entries.
'\"
'\" .AP type name in/out [indent]
'\"	Start paragraph describing an argument to a library procedure.
'\"	type is type of argument (int, etc.), in/out is either "in", "out",
'\"	or "in/out" to describe whether procedure reads or modifies arg,
'\"	and indent is equivalent to second arg of .IP (shouldn't ever be
'\"	needed;  use .AS below instead)
'\"
'\" .AS [type [name]]
'\"	Give maximum sizes of arguments for setting tab stops.  Type and
'\"	name are examples of largest possible arguments that will be passed
'\"	to .AP later.  If args are omitted, default tab stops are used.
'\"
'\" .BS
'\"	Start box enclosure.  From here until next .BE, everything will be
'\"	enclosed in one large box.
'\"
'\" .BE
'\"	End of box enclosure.
'\"
'\" .VS
'\"	Begin vertical sidebar, for use in marking newly-changed parts
'\"	of man pages.
'\"
'\" .VE
'\"	End of vertical sidebar.
'\"
'\" .DS
'\"	Begin an indented unfilled display.
'\"
'\" .DE
'\"	End of indented unfilled display.
'\"
'\" @(#) man.macros 1.3 95/05/06 15:19:04
'\"
'\"	# Set up traps and other miscellaneous stuff for Tcl/Tk man pages.
.if t .wh -1.3i ^B
.nr ^l \n(.l
.ad b
'\"	# Start an argument description
.de AP
.ie !"\\$4"" .TP \\$4
.el \{\
.   ie !"\\$2"" .TP \\n()Cu
.   el          .TP 15
.\}
.ie !"\\$3"" \{\
.ta \\n()Au \\n()Bu
\&\\$1	\\fI\\$2\\fP	(\\$3)
.\".b
.\}
.el \{\
.br
.ie !"\\$2"" \{\
\&\\$1	\\fI\\$2\\fP
.\}
.el \{\
\&\\fI\\$1\\fP
.\}
.\}
..
'\"	# define tabbing values for .AP
.de AS
.nr )A 10n
.if !"\\$1"" .nr )A \\w'\\$1'u+3n
.nr )B \\n()Au+15n
.\"
.if !"\\$2"" .nr )B \\w'\\$2'u+\\n()Au+3n
.nr )C \\n()Bu+\\w'(in/out)'u+2n
..
'\"	# BS - start boxed text
'\"	# ^y = starting y location
'\"	# ^b = 1
.de BS
.br
.mk ^y
.nr ^b 1u
.if n .nf
.if n .ti 0
.if n \l'\\n(.lu\(ul'
.if n .fi
..
'\"	# BE - end boxed text (draw box now)
.de BE
.nf
.ti 0
.mk ^t
.ie n \l'\\n(^lu\(ul'
.el \{\
.\"	Draw four-sided box normally, but don't draw top of
.\"	box if the box started on an earlier page.
.ie !\\n(^b-1 \{\
\h'-1.5n'\L'|\\n(^yu-1v'\l'\\n(^lu+3n\(ul'\L'\\n(^tu+1v-\\n(^yu'\l'|0u-1.5n\(ul'
.\}
.el \}\
\h'-1.5n'\L'|\\n(^yu-1v'\h'\\n(^lu+3n'\L'\\n(^tu+1v-\\n(^yu'\l'|0u-1.5n\(ul'
.\}
.\}
.fi
.br
.nr ^b 0
..
'\"	# VS - start vertical sidebar
'\"	# ^Y = starting y location
'\"	# ^v = 1 (for troff;  for nroff this doesn't matter)
.de VS
.mk ^Y
.ie n 'mc \s12\(br\s0
.el .nr ^v 1u
..
'\"	# VE - end of vertical sidebar
.de VE
.ie n 'mc
.el \{\
.ev 2
.nf
.ti 0
.mk ^t
\h'|\\n(^lu+3n'\L'|\\n(^Yu-1v\(bv'\v'\\n(^tu+1v-\\n(^Yu'\h'-|\\n(^lu+3n'
.sp -1
.fi
.ev
.\}
.nr ^v 0
..
'\"	# Special macro to handle page bottom:  finish off current
'\"	# box/sidebar if in box/sidebar mode, then invoked standard
'\"	# page bottom macro.
.de ^B
.ev 2
'ti 0
'nf
.mk ^t
.if \\n(^b \{\
.\"	Draw three-sided box if this is the box's first page,
.\"	draw two sides but no top otherwise.
.ie !\\n(^b-1 \h'-1.5n'\L'|\\n(^yu-1v'\l'\\n(^lu+3n\(ul'\L'\\n(^tu+1v-\\n(^yu'\h'|0u'\c
.el \h'-1.5n'\L'|\\n(^yu-1v'\h'\\n(^lu+3n'\L'\\n(^tu+1v-\\n(^yu'\h'|0u'\c
.\}
.if \\n(^v \{\
.nr ^x \\n(^tu+1v-\\n(^Yu
\kx\h'-\\nxu'\h'|\\n(^lu+3n'\ky\L'-\\n(^xu'\v'\\n(^xu'\h'|0u'\c
.\}
.bp
'fi
.ev
.if \\n(^b \{\
.mk ^y
.nr ^b 2
.\}
.if \\n(^v \{\
.mk ^Y
.\}
..
'\"	# DS - begin display
.de DS
.RS
.nf
.sp
..
'\"	# DE - end display
.de DE
.fi
.RE
.sp
..
.TH informixTcl n 8.2 Tcl "Access to INFORMIX Databases"
.BS
.SH NAME
::informixTcl::inflogon, ::informixTcl::inflogoff, ::informixTcl::inflogoffall, ::informixTcl::infdosql, ::informixTcl::infprepare, ::informixTcl::infcommit, ::informixTcl::infrollback, ::informixTcl::inffetch, ::informixTcl::infexecute, ::informixTcl::infclose, ::informixTcl::infrelease, ::informixTcl::infget, ::informixTcl::infset \- INFORMIX Database access commands
.SH SYNOPSIS
.nf
\fB::informixTcl::inflogon\fR ?\fIDatabase\fR? ?\fIUsername\fR? ?\fIPassword\fR? ?\fIAutoCommit\fR?
.sp
\fB::informixTcl::inflogoff\fR \fILogon-Handle\fR
.sp
\fB::informixTcl::inflogoffall\fR
.sp
\fB::informixTcl::infdosql\fR \fILogon-Handle\fR \fISQL-Statement\fR
.sp
\fB::informixTcl::infprepare\fR \fILogon-Handle\fR \fISQL-Statement\fR
.sp
\fB::informixTcl::infexecute\fR \fIStatement-Handle\fR ?\fIParameters...\fR?
.sp
\fB::informixTcl::inffetch\fR \fIStatement-Handle\fR ?\fIVariables...\fR?
.sp
\fB::informixTcl::infclose\fR \fIStatement-Handle\fR
.sp
\fB::informixTcl::infrelease\fR \fIStatement-Handle\fR
.sp
\fB::informixTcl::infcommit\fR \fILogon-Handle\fR
.sp
\fB::informixTcl::infrollback\fR \fILogon-Handle\fR
.sp
\fB::informixTcl::infget\fR \fILogon-Handle\fR \fIKeyword\fR
.sp
\fB::informixTcl::infget\fR \fIStatement-Handle\fR \fIKeyword\fR
.sp
\fB::informixTcl::infset\fR \fILogon-Handle\fR \fIKeyword\fR \fIValue\fR

\fB

.SH DESCRIPTION
.PP
This TCL extension provides several commands to access INFORMIX
database servers. There is full support for unlimited number of concurrent 
connections and statement cursors, parameter substitution of prepared 
statements, calling procedures with input/output handling and blob processing
(simple large objects only).
Since this package depends on the TCL Object Interface and the
stubs interface, at least TCL 8.2 is required. This package was inspired by 
DBD::informix (Version 0.59), the INFORMIX interface for Perl 5,
wich was created by Jonathan Leffler, Alligator Descartes and others.
.TP
\fB::informixTcl::inflogon\fR ?\fIDatabase\fR? ?\fIUsername\fR? ?\fIPassword\fR? ?\fIAutoCommit\fR?
.RS
Logs on to an INFORMIX database server. The argument \fIDatabase\fR can be 
any valid format of the DATABASE or CONNECT statements:
.DS
.ta 3c 6c 9c
    dbase               # 'Local' database
    dbase@server1       # Database on (remote) server 
                          (as defined in sqlhosts)
    @server1            # Connection to (remote) server 
                          but no database
    /some/where/dbase   # Connect to local SE database    
.DE
On successful completion the command returns a Logon-Handle which must be
used in subsequent database operations on this connection. The optional
parameter AutoCommit is ignored when connecting to non logged databases.
.PP
If the argument \fIDatabase\fR is omitted a default connection is established.
This connection can be used to create or drop databases.
.RE
.TP
\fB::informixTcl::inflogoff\fR \fILogon-Handle\fR
.RS
Logs off the connection specified by \fILogon-Handle\fR. Open statements
belonging to this connection are closed and open transactions are
committed. After completion the Logon-Handle is not available any more.
.RE
.TP
\fB::informixTcl::inflogoffall\fR
.RS
Logs off any open database connection.
.RE
.TP
\fB::informixTcl::infdosql\fR \fILogon-Handle\fR \fISQL-Statement\fR
.RS
Executes the SQL-Statement. The statement must be a non select statement or 
a call to a procedure returning no arguments. 
.RE
.TP
\fB::informixTcl::infprepare\fR \fILogon-Handle\fR \fISQL-Statement\fR
.RS
Prepares the SQL-Statement. Returns a Statement-Handle, if successful. The
SQL-Statement may contain "?" as placeholders to sustitute values
in subsequent executions of the prepared statement.
.RE
.TP
\fB::informixTcl::infexecute\fR \fIStatement-Handle\fR ?\fIParameters...\fR?
.RS
Executes a prepared statement. The number of parameters must match the
number of placeholder indicators in the prepared statement. If the
statement is a select statement a cursor is opended and the rows must be 
fetched by subsequent calls to \fI::informixTcl::inffetch\fR. For other 
statements the Statement-Handle can be used for subsequent executions of the
prepared statements.
.RE
.TP
\fB::informixTcl::inffetch\fR \fIStatement-Handle\fR ?\fIVariables...\fR?
.RS
Fetches a single row from the Statement-Handle as a TCL list. Null values
are returned as empty list elements. If there are no more rows, SQL error
100 is thrown.
.PP
The row can also be stored into TCL-Variables. In this case the number of
variables must match the number of rows returned.
.RE
.TP
\fB::informixTcl::infclose\fR \fIStatement-Handle\fR
.RS
Closes a cursor belonging to the Statement-Handle. The Statement-Handle can
now be used for subsequent executions of the prepared statement.
.RE
.TP
\fB::informixTcl::infrelease\fR \fIStatement-Handle\fR
.RS
Releases a Statement-Handle freeing all its ressources. After completion 
the Statement-Handle is not available any more.
.RE
.TP
\fB::informixTcl::infcommit\fR \fILogon-Handle\fR
.RS
Commits an open transaction.
.RE
.TP
\fB::informixTcl::infrollback\fR \fILogon-Handle\fR
.RS
Rolls back an open transaction. 
.RE
.TP
\fB::informixTcl::infget\fR \fILogon-Handle\fR \fIParameter\fR
.RS
Returns information about a database connection. \fIParameter\fR can be one of
the following:
.DS
.ta 3c 6c 9c
       ConnectionName DatabaseName IsConnected
       IsOnlineDb IsModeAnsi IsLoggedDb ChopBlanks
       IsInTransaction HasAutoCommit
.DE
.PP
\fBConnectionName\fR
.br
Returns the Connection Name. 
.PP
\fBDatabaseName\fR
.br
Returns the name of the database.
.PP
\fBIsConnected\fR
.br
Returns 1 if the handle is connected to a database, 0 otherwise.
.PP
\fBIsOnlineDb\fR
.br
Returns 1 if the handle not connected to a SE server, 0 otherwise.
.PP
\fBIsModeAnsi\fR
.br
Returns 1 if the database is in ANSI mode, 0 otherwise.
.PP
\fBIsLoggedDb\fR
.br
Returns 1 if the database is logged, 0 otherwise.
.PP
\fBChopBlanks\fR
.br
Returns 1 if trailing blanks are removed, 0 otherwise. 
.PP
\fBIsInTransaction\fR
.br
Returns 1 if the connection has open transactions, 0 otherwise.
.PP
\fBHasAutoCommit\fR
.br
Returns 1 if the connection is in AutoCommit mode, 0 otherwise.
.RE
.TP
\fB::informixTcl::infget\fR \fIStatement-Handle\fR \fIParameter\fR
.RS
Returns information about a Statement-Handle. \fIParameter\fR can be one of
the following:
.DS
.ta 3c 6c 9c
       State NBlobs NCols NBound
       NRows NInputParams ColNames
       ColNullable Coltype ColLength
       ColScale ColPrecision
.DE
.PP
\fBState\fR
.br
Returns the state of the statement. The state is either \fIUnused\fR,
\fIPrepared\fR, \fIAllocated\fR, \fIDescribed\fR, \fIDeclared\fR,
\fIOpened\fR or \fIFinished\fR.
.PP
\fBNBlobs\fR
.br
Returns the number of blobs within the row of a select statement.
.PP
\fBNCols\fR
.br
Returns the number of columns of a select statement.
.PP
\fBNBound\fR
.br
Returns the number of bind variables.
.PP
\fBNRows\fR
.br
Returns the number of rows processed by the statement.
.PP
\fBNInputParams\fR
.br
Returns the number of input parameters of the statement.
.PP
\fBColNames\fR
.br
Returns the column names as a TCL list.
.PP
\fBColNullable\fR
.br
Returns a TCL list with a nullable indicator for each column. 1 means the
column may have null values, 0 otherwise.
.PP
\fBColType\fR
.br
Returns the data type of the columns as a TCL list.
.PP
\fBColLength\fR
.br
Returns the length of the columns as as a TCL list.
.PP
\fBColScale\fR
.br
Returns the scale of the columns as a TCL list. This only holds for
decimal and money data types.
.PP
\fBColPrecision\fR
.br
Returns the precision of the columns as a TCL list. This only holds for
decimal and money data types.
.RE

.TP
\fB::informixTcl::infset\fR \fILogon-Handle\fR \fIParameter\fR \fIValue\fR
.RS
Configure properties of the Logon-Handle. Parameters can be:
.DS
.ta 3c 6c 9c
       ChopBlanks
.DE
.PP
\fBChopBlanks\fR
.br
If \fIValue\fR is 1, then trailing blanks of character columns are removed
when fetched. The default value is 0 where trailing blanks are retained.
.RE

.SH VARIABLES
The \fI::informixTcl::infmsg\fR array provides status and error information. 
.TP
\fBversion\fR
.RS
Returns the version number of \fIinformixTcl\fR.
.RE
.TP
\fBerrtxt\fR
.RS
Returns the text of the last error message.
.RE
.TP
\fBerrnum\fR
.RS
Returns the number of the last error message.
.RE
.TP
\fBdebug\fR
.RS
Returns the debug level. This array element controls the debug output of this
package. Values may be 0 (no debug output) to 6 (activate all debug output). This variable is read-write. The default value is 0.
.RE
.TP
\fBmulticonnections\fR
.RS
Returns whether the package is able to support concurrent connections to 
databases. In this case the element has the value 1, otherwise 0. 
.RE
.TP
\fBprodversion\fR
.RS
Returns the ESQL/C version as a three digit number.
.RE
.SH KEYWORDS
SQL, Informix, Databases
